unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  VclTee.TeeGDIPlus, Vcl.Buttons, VCLTee.TeEngine, VCLTee.Series,
  VCLTee.TeeProcs, VCLTee.Chart, system.Math, system.UITypes;

type
  TForm1 = class(TForm)
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    LabeledEdit3: TLabeledEdit;
    RadioGroup1: TRadioGroup;
    Chart1: TChart;
    Series1: TBarSeries;
    BitBtn1: TBitBtn;
    Memo1: TMemo;
    Series2: TPointSeries;
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
var
  Epsilon: double;

const
// doubleŌvZłK}֐̍ől
// exp ̌vZŐ܂
  max_double_arg: double  = 169;


//xk[CB(2)AB(4)AB(6)A...AB(16)

  B : array[1..8] of double = ( 1.0 / 6,           // B(2)
                                  -1.0 / 30,
                                   1.0 / 42,
                                  -1.0 / 30,
                                   5.0 / 66,
                                -691.0 / 2730,
                                   7.0 / 6,
                               -3617.0 / 510);     // B(16)

  m: integer = sizeof(B) div sizeof(double);

// K}֐
function Gamma(x: double): double;
var
  i : integer;
  sum : double;
  xx, v  : double;
  xj  : double;
  lng : double;
  ln_sqrt_2pi: double;
begin
  ln_sqrt_2pi := ln(sqrt(2 * pi));                    // = ln(2 * pi) / 2;
  sum := 0;
  v := 1;
	while x < m do begin
    v := v * x;
    x := x + 1;
  end;
  xx := x * x;
  xj := x;
  lng := ln_sqrt_2pi - x + (x - 0.5) * ln(x) - ln(v);
  for i := 1 to  m do begin
    sum := sum + B[i] / (i * 2 * (2 * i - 1)) / xj;
    xj := xj * xx;
  end;
  result := exp(sum + lng);
end;

// (a, x)  PsSK}֐
function incomplete_gamma1(a, x: double): double;
var
  k : integer;
  term, previous : double;
begin
  result := 0;
	if x = 0 then exit;
	term := exp(a * ln(x) - x) / a;
  result := term;
	for k := 1 to 1000 do begin
		term := term * x / (a + k);
		previous := result;
    result := result + term;
		if result = previous then begin
      exit;
    end;
	end;
	Form1.Memo1.Lines.add ('p_gamma(): ܂');
end;

// (a, x)  QsSK}֐
function incomplete_gamma2(a, x: double): double;
var
  k : integer;
  w, temp, previous : double;
  la, lb : double;
begin
	if x < 1 + a then begin
    result := Gamma(a) - incomplete_gamma1(a, x);
    exit;
  end;
  la := 1;                        // Laguerrȇ
  lb := 1 + x - a;
	w := exp(a * ln(x) - x);
	result := w / lb;
	for k := 2  to 1000 do begin
		temp := ((k - 1 - a) * (lb - la) + (k + x) * lb) / k;
		la := lb;
    lb := temp;
		w := w * (k - 1 - a) / k;
		temp := w / (la * lb);
		previous := result;
    result := result + temp;
		if result = previous then exit;
	end;
	Form1.Memo1.Lines.add ('q_gamma: ܂');
end;

// mʂ̌vZ
function probability_mass(l: double; k:double): double;
begin
  result := power(l, k) * exp(-l) / Gamma(k + 1);
end;

// vZ̎s
procedure TForm1.BitBtn1Click(Sender: TObject);
var
  i, k: integer;
  l, m, p, x: double;
  min, max: integer;
  pl, ppl : double;
  Q, s : double;
  dp : double;
begin
  val(LabeledEdit1.Text, l, i);
  if i <> 0 then begin
    MessageDlg('ɂ̒lɊԈႢ܂B', mtInformation,
      [mbOk], 0, mbOk);
    exit;
  end;
  val(LabeledEdit2.Text, k, i);
  if i <> 0 then begin
    MessageDlg('k̒lɊԈႢ܂B', mtInformation,
      [mbOk], 0, mbOk);
    exit;
  end;
  val(LabeledEdit3.Text, p, i);
  if i <> 0 then begin
    MessageDlg('P̒lɊԈႢ܂B', mtInformation,
      [mbOk], 0, mbOk);
    exit;
  end;
  if p >= 1 then begin
    MessageDlg('P̒l傫܂B', mtInformation,
      [mbOk], 0, mbOk);
    exit;
  end;
  min := 0;
  max := round(l) * 2;
  if max < 13 then max := 13;
  if k > trunc(max_double_arg) then begin
    MessageDlg('k̒l傫ČvZł܂B', mtInformation,
      [mbOk], 0, mbOk);
    exit;
  end;
  if (k > max) then begin
    if k <= max_double_arg then max := trunc(max_double_arg);
    if k < max_double_arg - 1 then max := k + 1;
  end;
  Series1.Clear;
  Series2.Clear;
  memo1.Clear;
  // m ݐϊm ̌vZ
  pl := 0;
  x := 0;
  s := 0;
  for i := min to max do begin
    m := probability_mass(l, i);                        // m
    if RadioGroup1.ItemIndex = 0 then begin
      if i < k then Series1.AddXY(i, m, '', clRed);
      if i = k then Series1.AddXY(i, m, '', clFuchsia);
      if i > k then Series1.AddXY(i, m, '', clBlue);
    end;
    if i <= k then pl := pl + m;                        // ݐϊm
    if i = k then x := m;
    if RadioGroup1.ItemIndex = 1 then begin
      s := s + m;                                       // ݐϊm
      Series2.AddXY(i, s);
    end;
  end;
  Q := 1 - pl + x;                                      // 㑤ݐϊm
  memo1.Lines.Add('p[Zg_(k=' + intTostr(k) + ')');
  memo1.Lines.Add('@@m @@@@f@' + floatTostr(x));
  memo1.Lines.Add('ݐϊm@@@P@' + floatTostr(pl));
  memo1.Lines.Add('㑤ݐϊm@@@Q@' + floatTostr(Q));
  // ݐϊmp[Zg_̌vZ
  // t֐̂ŁAߎ@ɂvZ
  x := trunc(max_double_arg);
  for i := 0 to trunc(max_double_arg) do begin
    ppl := incomplete_gamma2(i + 1, l) / Gamma(i + 1);  // ݐϊm
    if ppl >= p then begin
      x := i;
      break;
    end;
  end;
  dp := 1;
  repeat
    x := x + dp;
    ppl := incomplete_gamma2(x, l) / Gamma(x);          // ݐϊm
    s := ppl - p;
    if s > 0 then begin
      x := x - dp;
      dp := dp / 2;
    end;
  until (abs(s) <= Epsilon) or (dp <= Epsilon);
  x := x - 1;
  memo1.Lines.Add('ݐϊm(P = ' + floatTostr(p) + ')');
  // sȂo
  memo1.Lines.Text := memo1.Lines.Text
                              + '@@p[Zg_@@@k@' + floatTostr(x);
//  memo1.Lines.Add('@@p[Zg_@@@k@' + floatTostr(x));

  k := trunc(x);
  if RadioGroup1.ItemIndex = 2 then begin
    for i := 0 to max do begin
      m := probability_mass(l, i);
      if i < k then Series1.AddXY(i, m, '', clRed);
      if i = k then Series1.AddXY(i, m, '', clFuchsia);
      if i > k then Series1.AddXY(i, m, '', clBlue);
    end;
  end;
end;

// ݒ
// epsilon̐ݒ
procedure TForm1.FormCreate(Sender: TObject);
var
  m, d: double;
begin
  LabeledEdit1.EditLabel.Caption := ' 0' + #13#10 + 'ꐔ(ϒl)';
  LabeledEdit2.EditLabel.Caption := 'k=1,2,3,c' + #13#10 + 'p[Zg_';
  LabeledEdit3.EditLabel.Caption := 'P 0' + #13#10 + 'ݐϊm';
  Epsilon := 1;
  d := 1;
  repeat
    Epsilon := Epsilon / 2;
    m := d + Epsilon;
  until d = m;
  Epsilon := Epsilon * 2;
end;

end.
